zfsboot revision 281843
1#!/bin/sh
2#-
3# Copyright (c) 2013 Allan Jude
4# Copyright (c) 2013 Devin Teske
5# All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15#
16# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
17# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
20# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26# SUCH DAMAGE.
27#
28# $FreeBSD: stable/10/usr.sbin/bsdinstall/scripts/zfsboot 281843 2015-04-22 01:08:40Z dteske $
29#
30############################################################ INCLUDES
31
32BSDCFG_SHARE="/usr/share/bsdconfig"
33. $BSDCFG_SHARE/common.subr || exit 1
34f_dprintf "%s: loading includes..." "$0"
35f_include $BSDCFG_SHARE/device.subr
36f_include $BSDCFG_SHARE/dialog.subr
37f_include $BSDCFG_SHARE/password/password.subr
38f_include $BSDCFG_SHARE/variable.subr
39
40############################################################ CONFIGURATION
41
42#
43# Default name of the boot-pool
44#
45: ${ZFSBOOT_POOL_NAME:=zroot}
46
47#
48# Default options to use when creating zroot pool
49#
50: ${ZFSBOOT_POOL_CREATE_OPTIONS:=-O compress=lz4 -O atime=off}
51
52#
53# Default name for the boot environment parent dataset
54#
55: ${ZFSBOOT_BEROOT_NAME:=ROOT}
56
57#
58# Default name for the primany boot environment
59#
60: ${ZFSBOOT_BOOTFS_NAME:=default}
61
62#
63# Default Virtual Device (vdev) type to create
64#
65: ${ZFSBOOT_VDEV_TYPE:=stripe}
66
67#
68# Should we use sysctl(8) vfs.zfs.min_auto_ashift=12 to force 4K sectors?
69#
70: ${ZFSBOOT_FORCE_4K_SECTORS:=1}
71
72#
73# Should we use geli(8) to encrypt the drives?
74# NB: Automatically enables ZFSBOOT_BOOT_POOL
75#
76: ${ZFSBOOT_GELI_ENCRYPTION=}
77
78#
79# Default path to the geli(8) keyfile used in drive encryption
80#
81: ${ZFSBOOT_GELI_KEY_FILE:=/boot/encryption.key}
82
83#
84# Create a separate boot pool?
85# NB: Automatically set when using geli(8) or MBR
86#
87: ${ZFSBOOT_BOOT_POOL=}
88
89#
90# Options to use when creating separate boot pool (if any)
91#
92: ${ZFSBOOT_BOOT_POOL_CREATE_OPTIONS:=}
93
94#
95# Default name for boot pool when enabled (e.g., geli(8) or MBR)
96#
97: ${ZFSBOOT_BOOT_POOL_NAME:=bootpool}
98
99#
100# Default size for boot pool when enabled (e.g., geli(8) or MBR)
101#
102: ${ZFSBOOT_BOOT_POOL_SIZE:=2g}
103
104#
105# Default disks to use (always empty unless being scripted)
106#
107: ${ZFSBOOT_DISKS:=}
108
109#
110# Default partitioning scheme to use on disks
111#
112: ${ZFSBOOT_PARTITION_SCHEME:=GPT}
113
114#
115# How much swap to put on each block device in the boot zpool
116# NOTE: Value passed to gpart(8); which supports SI unit suffixes.
117#
118: ${ZFSBOOT_SWAP_SIZE:=2g}
119
120#
121# Should we use geli(8) to encrypt the swap?
122#
123: ${ZFSBOOT_SWAP_ENCRYPTION=}
124
125#
126# Should we use gmirror(8) to mirror the swap?
127#
128: ${ZFSBOOT_SWAP_MIRROR=}
129
130#
131# Default ZFS datasets for root zpool
132#
133# NOTE: Requires /tmp, /var/tmp, /$ZFSBOOT_BOOTFS_NAME/$ZFSBOOT_BOOTFS_NAME
134# NOTE: Anything after pound/hash character [#] is ignored as a comment.
135#
136f_isset ZFSBOOT_DATASETS || ZFSBOOT_DATASETS="
137	# DATASET	OPTIONS (comma or space separated; or both)
138
139	# Boot Environment [BE] root and default boot dataset
140	/$ZFSBOOT_BEROOT_NAME				mountpoint=none
141	/$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME	mountpoint=/
142
143	# Compress /tmp, allow exec but not setuid
144	/tmp		mountpoint=/tmp,exec=on,setuid=off
145
146	# Don't mount /usr so that 'base' files go to the BEROOT
147	/usr		mountpoint=/usr,canmount=off
148
149	# Home directories separated so they are common to all BEs
150	/usr/home	# NB: /home is a symlink to /usr/home
151
152	# Ports tree
153	/usr/ports	setuid=off
154
155	# Source tree (compressed)
156	/usr/src
157
158	# Create /var and friends
159	/var		mountpoint=/var,canmount=off
160	/var/crash	exec=off,setuid=off
161	/var/log	exec=off,setuid=off
162	/var/mail	atime=on
163	/var/tmp	setuid=off
164" # END-QUOTE
165
166#
167# If interactive and the user has not explicitly chosen a vdev type or disks,
168# make the user confirm scripted/default choices when proceeding to install.
169#
170: ${ZFSBOOT_CONFIRM_LAYOUT:=1}
171
172############################################################ GLOBALS
173
174#
175# Format of a line in printf(1) syntax to add to fstab(5)
176#
177FSTAB_FMT="%s\t\t%s\t%s\t%s\t\t%s\t%s\n"
178
179#
180# Command strings for various tasks
181#
182CHMOD_MODE='chmod %s "%s"'
183DD_WITH_OPTIONS='dd if="%s" of="%s" %s'
184ECHO_APPEND='echo "%s" >> "%s"'
185GELI_ATTACH='geli attach -j - -k "%s" "%s"'
186GELI_DETACH_F='geli detach -f "%s"'
187GELI_PASSWORD_INIT='geli init -b -B "%s" -e %s -J - -K "%s" -l 256 -s 4096 "%s"'
188GPART_ADD='gpart add -t %s "%s"'
189GPART_ADD_INDEX='gpart add -i %s -t %s "%s"'
190GPART_ADD_INDEX_WITH_SIZE='gpart add -i %s -t %s -s %s "%s"'
191GPART_ADD_LABEL='gpart add -l %s -t %s "%s"'
192GPART_ADD_LABEL_WITH_SIZE='gpart add -l %s -t %s -s %s "%s"'
193GPART_BOOTCODE='gpart bootcode -b "%s" "%s"'
194GPART_BOOTCODE_PART='gpart bootcode -b "%s" -p "%s" -i %s "%s"'
195GPART_CREATE='gpart create -s %s "%s"'
196GPART_DESTROY_F='gpart destroy -F "%s"'
197GPART_SET_ACTIVE='gpart set -a active -i %s "%s"'
198GRAID_DELETE='graid delete "%s"'
199LN_SF='ln -sf "%s" "%s"'
200MKDIR_P='mkdir -p "%s"'
201MOUNT_TYPE='mount -t %s "%s" "%s"'
202PRINTF_CONF="printf '%s=\"%%s\"\\\n' %s >> \"%s\""
203PRINTF_FSTAB='printf "$FSTAB_FMT" "%s" "%s" "%s" "%s" "%s" "%s" >> "%s"'
204SHELL_TRUNCATE=':> "%s"'
205SWAP_GMIRROR_LABEL='gmirror label swap %s'
206SYSCTL_ZFS_MIN_ASHIFT_12='sysctl vfs.zfs.min_auto_ashift=12'
207UMOUNT='umount "%s"'
208ZFS_CREATE_WITH_OPTIONS='zfs create %s "%s"'
209ZFS_SET='zfs set "%s" "%s"'
210ZFS_UNMOUNT='zfs unmount "%s"'
211ZPOOL_CREATE_WITH_OPTIONS='zpool create %s "%s" %s %s'
212ZPOOL_DESTROY='zpool destroy "%s"'
213ZPOOL_EXPORT='zpool export "%s"'
214ZPOOL_IMPORT_WITH_OPTIONS='zpool import %s "%s"'
215ZPOOL_LABELCLEAR_F='zpool labelclear -f "%s"'
216ZPOOL_SET='zpool set %s "%s"'
217
218#
219# Strings that should be moved to an i18n file and loaded with f_include_lang()
220#
221hline_alnum_arrows_punc_tab_enter="Use alnum, arrows, punctuation, TAB or ENTER"
222hline_arrows_space_tab_enter="Use arrows, SPACE, TAB or ENTER"
223hline_arrows_tab_enter="Press arrows, TAB or ENTER"
224msg_an_unknown_error_occurred="An unknown error occurred"
225msg_back="Back"
226msg_cancel="Cancel"
227msg_change_selection="Change Selection"
228msg_configure_options="Configure Options:"
229msg_detailed_disk_info="gpart(8) show %s:\n%s\n\ncamcontrol(8) inquiry %s:\n%s\n\n\ncamcontrol(8) identify %s:\n%s\n"
230msg_disk_info="Disk Info"
231msg_disk_info_help="Get detailed information on disk device(s)"
232msg_disk_singular="disk"
233msg_disk_plural="disks"
234msg_encrypt_disks="Encrypt Disks?"
235msg_encrypt_disks_help="Use geli(8) to encrypt all data partitions"
236msg_error="Error"
237msg_force_4k_sectors="Force 4K Sectors?"
238msg_force_4k_sectors_help="Use sysctl(8) vfs.zfs.min_auto_ashift=12 to force 4K sectors"
239msg_freebsd_installer="FreeBSD Installer"
240msg_geli_password="Enter a strong passphrase, used to protect your encryption keys. You will be required to enter this passphrase each time the system is booted"
241msg_geli_setup="Initializing encryption on selected disks,\n this will take several seconds per disk"
242msg_install="Install"
243msg_install_desc="Proceed with Installation"
244msg_install_help="Create ZFS boot pool with displayed options"
245msg_invalid_boot_pool_size="Invalid boot pool size \`%s'"
246msg_invalid_disk_argument="Invalid disk argument \`%s'"
247msg_invalid_index_argument="Invalid index argument \`%s'"
248msg_invalid_swap_size="Invalid swap size \`%s'"
249msg_invalid_virtual_device_type="Invalid Virtual Device type \`%s'"
250msg_last_chance_are_you_sure="Last Chance! Are you sure you want to destroy\nthe current contents of the following disks:\n\n   %s"
251msg_last_chance_are_you_sure_color='\\ZrLast Chance!\\ZR Are you \\Z1sure\\Zn you want to \\Zr\\Z1destroy\\Zn\nthe current contents of the following disks:\n\n   %s'
252msg_mirror_desc="Mirror - n-Way Mirroring"
253msg_mirror_help="[2+ Disks] Mirroring provides the best performance, but the least storage"
254msg_missing_disk_arguments="missing disk arguments"
255msg_missing_one_or_more_scripted_disks="Missing one or more scripted disks!"
256msg_no="NO"
257msg_no_disks_present_to_configure="No disk(s) present to configure"
258msg_no_disks_selected="No disks selected."
259msg_not_enough_disks_selected="Not enough disks selected. (%u < %u minimum)"
260msg_null_disk_argument="NULL disk argument"
261msg_null_index_argument="NULL index argument"
262msg_null_poolname="NULL poolname"
263msg_ok="OK"
264msg_partition_scheme="Partition Scheme"
265msg_partition_scheme_help="Toggle between GPT and MBR partitioning schemes"
266msg_please_enter_a_name_for_your_zpool="Please enter a name for your zpool:"
267msg_please_enter_amount_of_swap_space="Please enter amount of swap space (SI-Unit suffixes\nrecommended; e.g., \`2g' for 2 Gigabytes):"
268msg_please_select_one_or_more_disks="Please select one or more disks to create a zpool:"
269msg_pool_name="Pool Name"
270msg_pool_name_cannot_be_empty="Pool name cannot be empty."
271msg_pool_name_help="Customize the name of the zpool to be created (Required)"
272msg_pool_type_disks="Pool Type/Disks:"
273msg_pool_type_disks_help="Choose type of ZFS Virtual Device and disks to use (Required)"
274msg_processing_selection="Processing selection..."
275msg_raidz1_desc="RAID-Z1 - Single Redundant RAID"
276msg_raidz1_help="[3+ Disks] Withstand failure of 1 disk. Recommended for: 3, 5 or 9 disks"
277msg_raidz2_desc="RAID-Z2 - Double Redundant RAID"
278msg_raidz2_help="[4+ Disks] Withstand failure of 2 disks. Recommended for: 4, 6 or 10 disks"
279msg_raidz3_desc="RAID-Z3 - Triple Redundant RAID"
280msg_raidz3_help="[5+ Disks] Withstand failure of 3 disks. Recommended for: 5, 7 or 11 disks"
281msg_rescan_devices="Rescan Devices"
282msg_rescan_devices_help="Scan for device changes"
283msg_select="Select"
284msg_select_a_disk_device="Select a disk device"
285msg_select_virtual_device_type="Select Virtual Device type:"
286msg_stripe_desc="Stripe - No Redundancy"
287msg_stripe_help="[1+ Disks] Striping provides maximum storage but no redundancy"
288msg_swap_encrypt="Encrypt Swap?"
289msg_swap_encrypt_help="Encrypt swap partitions with temporary keys, discarded on reboot"
290msg_swap_mirror="Mirror Swap?"
291msg_swap_mirror_help="Mirror swap partitions for redundancy, breaks crash dumps"
292msg_swap_size="Swap Size"
293msg_swap_size_help="Customize how much swap space is allocated to each selected disk"
294msg_these_disks_are_too_small="These disks are too small given the amount of requested\nswap (%s) and/or geli(8) (%s) partitions, which would\ntake 50%% or more of each of the following selected disk\ndevices (not recommended):\n\n  %s\n\nRecommend changing partition size(s) and/or selecting a\ndifferent set of devices."
295msg_uefi_not_supported="The FreeBSD UEFI loader does not currently support booting root-on-ZFS. Your system will need to boot in legacy (CSM) mode.\nDo you want to continue?"
296msg_unable_to_get_disk_capacity="Unable to get disk capacity of \`%s'"
297msg_unsupported_partition_scheme="%s is an unsupported partition scheme"
298msg_user_cancelled="User Cancelled."
299msg_yes="YES"
300msg_zfs_configuration="ZFS Configuration"
301
302############################################################ FUNCTIONS
303
304# dialog_menu_main
305#
306# Display the dialog(1)-based application main menu.
307#
308dialog_menu_main()
309{
310	local title="$DIALOG_TITLE"
311	local btitle="$DIALOG_BACKTITLE"
312	local prompt="$msg_configure_options"
313	local force4k="$msg_no"
314	local usegeli="$msg_no"
315	local swapgeli="$msg_no"
316	local swapmirror="$msg_no"
317	[ "$ZFSBOOT_FORCE_4K_SECTORS" ] && force4k="$msg_yes"
318	[ "$ZFSBOOT_GELI_ENCRYPTION" ] && usegeli="$msg_yes"
319	[ "$ZFSBOOT_SWAP_ENCRYPTION" ] && swapgeli="$msg_yes"
320	[ "$ZFSBOOT_SWAP_MIRROR" ] && swapmirror="$msg_yes"
321	local disks n disks_grammar
322	f_count n $ZFSBOOT_DISKS
323	{ [ $n -eq 1 ] && disks_grammar=$msg_disk_singular; } || 
324		disks_grammar=$msg_disk_plural # grammar
325	local menu_list="
326		'>>> $msg_install'        '$msg_install_desc'
327		                          '$msg_install_help'
328		'T $msg_pool_type_disks'  '$ZFSBOOT_VDEV_TYPE: $n $disks_grammar'
329                                          '$msg_pool_type_disks_help'
330		'- $msg_rescan_devices'   '*'
331		                          '$msg_rescan_devices_help'
332		'- $msg_disk_info'        '*'
333		                          '$msg_disk_info_help'
334		'N $msg_pool_name'        '$ZFSBOOT_POOL_NAME'
335		                          '$msg_pool_name_help'
336		'4 $msg_force_4k_sectors' '$force4k'
337		                          '$msg_force_4k_sectors_help'
338		'E $msg_encrypt_disks'    '$usegeli'
339		                          '$msg_encrypt_disks_help'
340		'P $msg_partition_scheme' '$ZFSBOOT_PARTITION_SCHEME'
341		                          '$msg_partition_scheme_help'
342		'S $msg_swap_size'        '$ZFSBOOT_SWAP_SIZE'
343		                          '$msg_swap_size_help'
344		'M $msg_swap_mirror'      '$swapmirror'
345		                          '$msg_swap_mirror_help'
346		'W $msg_swap_encrypt'     '$swapgeli'
347		                          '$msg_swap_encrypt_help'
348	" # END-QUOTE
349	local defaultitem= # Calculated below
350	local hline="$hline_alnum_arrows_punc_tab_enter"
351
352	local height width rows
353	eval f_dialog_menu_with_help_size height width rows \
354		\"\$title\" \"\$btitle\" \"\$prompt\" \"\$hline\" $menu_list
355
356	# Obtain default-item from previously stored selection
357	f_dialog_default_fetch defaultitem
358
359	local menu_choice
360	menu_choice=$( eval $DIALOG \
361		--title \"\$title\"              \
362		--backtitle \"\$btitle\"         \
363		--hline \"\$hline\"              \
364		--item-help                      \
365		--ok-label \"\$msg_select\"      \
366		--cancel-label \"\$msg_cancel\"  \
367		--default-item \"\$defaultitem\" \
368		--menu \"\$prompt\"              \
369		$height $width $rows             \
370		$menu_list                       \
371		2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
372	)
373	local retval=$?
374	f_dialog_data_sanitize menu_choice
375	f_dialog_menutag_store "$menu_choice"
376
377	# Only update default-item on success
378	[ $retval -eq $DIALOG_OK ] && f_dialog_default_store "$menu_choice"
379
380	return $retval
381}
382
383# dialog_last_chance $disks ...
384#
385# Display a list of the disks that the user is about to destroy. The default
386# action is to return error status unless the user explicitly (non-default)
387# selects "Yes" from the noyes dialog.
388#
389dialog_last_chance()
390{
391	local title="$DIALOG_TITLE"
392	local btitle="$DIALOG_BACKTITLE"
393	local prompt # Calculated below
394	local hline="$hline_arrows_tab_enter"
395
396	local height=8 width=50 prefix="   "
397	local plen=${#prefix} list= line=
398	local max_width=$(( $width - 3 - $plen ))
399
400	local yes no defaultno extra_args format
401	if [ "$USE_XDIALOG" ]; then
402		yes=ok no=cancel defaultno=default-no
403		extra_args="--wrap --left"
404		format="$msg_last_chance_are_you_sure"
405	else
406		yes=yes no=no defaultno=defaultno
407		extra_args="--colors --cr-wrap"
408		format="$msg_last_chance_are_you_sure_color"
409	fi
410
411	local disk line_width
412	for disk in $*; do
413		if [ "$line" ]; then
414			line_width=${#line}
415		else
416			line_width=$plen
417		fi
418		line_width=$(( $line_width + 1 + ${#disk} ))
419		# Add newline before disk if it would exceed max_width
420		if [ $line_width -gt $max_width ]; then
421			list="$list$line\n"
422			line="$prefix"
423			height=$(( $height + 1 ))
424		fi
425		# Add the disk to the list
426		line="$line $disk"
427	done
428	# Append the left-overs
429	if [ "${line#$prefix}" ]; then
430		list="$list$line"
431		height=$(( $height + 1 ))
432	fi
433
434	# Add height for Xdialog(1)
435	[ "$USE_XDIALOG" ] && height=$(( $height + $height / 5 + 3 ))
436
437	prompt=$( printf "$format" "$list" )
438	f_dprintf "%s: Last Chance!" "$0"
439	$DIALOG \
440		--title "$title"        \
441		--backtitle "$btitle"   \
442		--hline "$hline"        \
443		--$defaultno            \
444		--$yes-label "$msg_yes" \
445		--$no-label "$msg_no"   \
446		$extra_args             \
447		--yesno "$prompt" $height $width
448}
449
450# dialog_menu_layout
451#
452# Configure Virtual Device type and disks to use for the ZFS boot pool. User
453# must select enough disks to satisfy the chosen vdev type.
454#
455dialog_menu_layout()
456{
457	local funcname=dialog_menu_layout
458	local title="$DIALOG_TITLE"
459	local btitle="$DIALOG_BACKTITLE"
460	local vdev_prompt="$msg_select_virtual_device_type"
461	local disk_prompt="$msg_please_select_one_or_more_disks"
462	local vdev_menu_list="
463		'stripe' '$msg_stripe_desc' '$msg_stripe_help'
464		'mirror' '$msg_mirror_desc' '$msg_mirror_help'
465		'raidz1' '$msg_raidz1_desc' '$msg_raidz1_help'
466		'raidz2' '$msg_raidz2_desc' '$msg_raidz2_help'
467		'raidz3' '$msg_raidz3_desc' '$msg_raidz3_help'
468	" # END-QUOTE
469	local disk_check_list= # Calculated below
470	local vdev_hline="$hline_arrows_tab_enter"
471	local disk_hline="$hline_arrows_space_tab_enter"
472
473	# Warn the user if vdev type is not valid
474	case "$ZFSBOOT_VDEV_TYPE" in
475	stripe|mirror|raidz1|raidz2|raidz3) : known good ;;
476	*)
477		f_dprintf "%s: Invalid virtual device type \`%s'" \
478			  $funcname "$ZFSBOOT_VDEV_TYPE"
479		f_show_err "$msg_invalid_virtual_device_type" \
480			   "$ZFSBOOT_VDEV_TYPE"
481		f_interactive || return $FAILURE
482	esac
483
484	# Calculate size of vdev menu once only
485	local vheight vwidth vrows
486	eval f_dialog_menu_with_help_size vheight vwidth vrows \
487		\"\$title\" \"\$btitle\" \"\$vdev_prompt\" \"\$vdev_hline\" \
488		$vdev_menu_list
489
490	# Get a list of probed disk devices
491	local disks=
492	debug= f_device_find "" $DEVICE_TYPE_DISK disks
493
494	# Prune out mounted md(4) devices that may be part of the boot process
495	local disk name new_list=
496	for disk in $disks; do
497		debug= $disk get name name
498		case "$name" in
499		md[0-9]*) f_mounted -b "/dev/$name" && continue ;;
500		esac
501		new_list="$new_list $disk"
502	done
503	disks="${new_list# }"
504
505	# Debugging
506	if [ "$debug" ]; then
507		local disk_names=
508		for disk in $disks; do
509			debug= $disk get name name
510			disk_names="$disk_names $name"
511		done
512		f_dprintf "$funcname: disks=[%s]" "${disk_names# }"
513	fi
514
515	if [ ! "$disks" ]; then
516		f_dprintf "No disk(s) present to configure"
517		f_show_err "$msg_no_disks_present_to_configure"
518		return $FAILURE
519	fi
520
521	# Lets sort the disks array to be more user friendly
522	f_device_sort_by name disks disks
523
524	#
525	# Operate in a loop so we can (if interactive) repeat if not enough
526	# disks are selected to satisfy the chosen vdev type or user wants to
527	# back-up to the previous menu.
528	#
529	local vardisk ndisks onoff selections vdev_choice breakout device
530	local valid_disks all_valid want_disks desc height width rows
531	while :; do
532		#
533		# Confirm the vdev type that was selected
534		#
535		if f_interactive && [ "$ZFSBOOT_CONFIRM_LAYOUT" ]; then
536			vdev_choice=$( eval $DIALOG \
537				--title \"\$title\"              \
538				--backtitle \"\$btitle\"         \
539				--hline \"\$vdev_hline\"         \
540				--ok-label \"\$msg_ok\"          \
541				--cancel-label \"\$msg_cancel\"  \
542				--item-help                      \
543				--default-item \"\$ZFSBOOT_VDEV_TYPE\" \
544				--menu \"\$vdev_prompt\"         \
545				$vheight $vwidth $vrows          \
546				$vdev_menu_list                  \
547				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
548			) || return $?
549				# Exit if user pressed ESC or chose Cancel/No
550			f_dialog_data_sanitize vdev_choice
551
552			ZFSBOOT_VDEV_TYPE="$vdev_choice"
553			f_dprintf "$funcname: ZFSBOOT_VDEV_TYPE=[%s]" \
554			          "$ZFSBOOT_VDEV_TYPE"
555		fi
556
557		# Determine the number of disks needed for this vdev type
558		want_disks=0
559		case "$ZFSBOOT_VDEV_TYPE" in
560		stripe) want_disks=1 ;;
561		mirror) want_disks=2 ;;
562		raidz1) want_disks=3 ;;
563		raidz2) want_disks=4 ;;
564		raidz3) want_disks=5 ;;
565		esac
566
567		#
568		# Warn the user if any scripted disks are invalid
569		#
570		valid_disks= all_valid=${ZFSBOOT_DISKS:+1} # optimism
571		for disk in $ZFSBOOT_DISKS; do
572			if debug= f_device_find -1 \
573				$disk $DEVICE_TYPE_DISK device
574			then
575				valid_disks="$valid_disks $disk"
576				continue
577			fi
578			f_dprintf "$funcname: \`%s' is not a real disk" "$disk"
579			all_valid=
580		done
581		if [ ! "$all_valid" ]; then
582			if [ "$ZFSBOOT_DISKS" ]; then
583				f_show_err \
584				    "$msg_missing_one_or_more_scripted_disks"
585			else
586				f_dprintf "No disks selected."
587				f_interactive ||
588					f_show_err "$msg_no_disks_selected"
589			fi
590			f_interactive || return $FAILURE
591		fi
592		ZFSBOOT_DISKS="${valid_disks# }"
593
594		#
595		# Short-circuit if we're running non-interactively
596		#
597		if ! f_interactive || [ ! "$ZFSBOOT_CONFIRM_LAYOUT" ]; then
598			f_count ndisks $ZFSBOOT_DISKS
599			[ $ndisks -ge $want_disks ] && break # to success
600
601			# Not enough disks selected
602			f_dprintf "$funcname: %s: %s (%u < %u minimum)" \
603				  "$ZFSBOOT_VDEV_TYPE" \
604			          "Not enough disks selected." \
605				  $ndisks $want_disks
606			f_interactive || return $FAILURE
607			msg_yes="$msg_change_selection" msg_no="$msg_cancel" \
608				f_yesno "%s: $msg_not_enough_disks_selected" \
609				"$ZFSBOOT_VDEV_TYPE" $ndisks $want_disks ||
610				return $FAILURE
611		fi
612
613		#
614		# Confirm the disks that were selected
615		# Loop until the user cancels or selects enough disks
616		#
617		breakout=
618		while :; do
619			# Loop over list of available disks, resetting state
620			for disk in $disks; do
621				f_isset _${disk}_status && _${disk}_status=
622			done
623
624			# Loop over list of selected disks and create temporary
625			# locals to map statuses onto up-to-date list of disks
626			for disk in $ZFSBOOT_DISKS; do
627				debug= f_device_find -1 \
628					$disk $DEVICE_TYPE_DISK disk
629				f_isset _${disk}_status ||
630					local _${disk}_status
631				_${disk}_status=on
632			done
633
634			# Create the checklist menu of discovered disk devices
635			disk_check_list=
636			for disk in $disks; do
637				desc=
638				$disk get name name
639				$disk get desc desc
640				f_shell_escape "$desc" desc
641				f_getvar _${disk}_status:-off onoff
642				disk_check_list="$disk_check_list
643					$name '$desc' $onoff"
644			done
645
646			eval f_dialog_checklist_size height width rows \
647				\"\$title\" \"\$btitle\" \"\$prompt\" \
648				\"\$hline\" $disk_check_list
649
650			selections=$( eval $DIALOG \
651				--title \"\$DIALOG_TITLE\"         \
652				--backtitle \"\$DIALOG_BACKTITLE\" \
653				--separate-output                  \
654				--hline \"\$hline\"                \
655				--ok-label \"\$msg_ok\"            \
656				--cancel-label \"\$msg_back\"      \
657				--checklist \"\$prompt\"           \
658				$height $width $rows               \
659				$disk_check_list                   \
660				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
661			) || break
662				# Loop if user pressed ESC or chose Cancel/No
663			f_dialog_data_sanitize selections
664
665			ZFSBOOT_DISKS="$selections"
666			f_dprintf "$funcname: ZFSBOOT_DISKS=[%s]" \
667			          "$ZFSBOOT_DISKS"
668
669			f_count ndisks $ZFSBOOT_DISKS
670			[ $ndisks -ge $want_disks ] &&
671				breakout=break && break
672
673			# Not enough disks selected
674			f_dprintf "$funcname: %s: %s (%u < %u minimum)" \
675				  "$ZFSBOOT_VDEV_TYPE" \
676			          "Not enough disks selected." \
677			          $ndisks $want_disks
678			msg_yes="$msg_change_selection" msg_no="$msg_cancel" \
679				f_yesno "%s: $msg_not_enough_disks_selected" \
680				"$ZFSBOOT_VDEV_TYPE" $ndisks $want_disks ||
681				break
682		done
683		[ "$breakout" = "break" ] && break
684		[ "$ZFSBOOT_CONFIRM_LAYOUT" ] || return $FAILURE
685	done
686
687	return $DIALOG_OK
688}
689
690# dialog_uefi_prompt
691#
692# Confirm that the user wants to continue with the installation on a BIOS
693# system when they have booted with UEFI
694#
695dialog_uefi_prompt()
696{
697	local title="$DIALOG_TITLE"
698	local btitle="$DIALOG_BACKTITLE"
699	local prompt # Calculated below
700	local hline="$hline_arrows_tab_enter"
701
702	local height=8 width=50 prefix="   "
703	local plen=${#prefix} list= line=
704	local max_width=$(( $width - 3 - $plen ))
705
706	local yes no defaultno extra_args format
707	if [ "$USE_XDIALOG" ]; then
708		yes=ok no=cancel defaultno=default-no
709		extra_args="--wrap --left"
710		format="$msg_uefi_not_supported"
711	else
712		yes=yes no=no defaultno=defaultno
713		extra_args="--cr-wrap"
714		format="$msg_uefi_not_supported"
715	fi
716
717	# Add height for Xdialog(1)
718	[ "$USE_XDIALOG" ] && height=$(( $height + $height / 5 + 3 ))
719
720	prompt=$( printf "$format" )
721	f_dprintf "%s: UEFI prompt" "$0"
722	$DIALOG \
723		--title "$title"        \
724		--backtitle "$btitle"   \
725		--hline "$hline"        \
726		--$yes-label "$msg_yes" \
727		--$no-label "$msg_no"   \
728		$extra_args             \
729		--yesno "$prompt" $height $width
730}
731
732# zfs_create_diskpart $disk $index
733#
734# For each block device to be used in the zpool, rather than just create the
735# zpool with the raw block devices (e.g., da0, da1, etc.) we create partitions
736# so we can have some real swap. This also provides wiggle room incase your
737# replacement drivers do not have the exact same sector counts.
738#
739# NOTE: $swapsize and $bootsize should be defined by the calling function.
740# NOTE: Sets $bootpart and $targetpart for the calling function.
741#
742zfs_create_diskpart()
743{
744	local funcname=zfs_create_diskpart
745	local disk="$1" index="$2"
746
747	# Check arguments
748	if [ ! "$disk" ]; then
749		f_dprintf "$funcname: NULL disk argument"
750		msg_error="$msg_error: $funcname" \
751			f_show_err "$msg_null_disk_argument"
752		return $FAILURE
753	fi
754	if [ "${disk#*[$IFS]}" != "$disk" ]; then
755		f_dprintf "$funcname: Invalid disk argument \`%s'" "$disk"
756		msg_error="$msg_error: $funcname" \
757			f_show_err "$msg_invalid_disk_argument" "$disk"
758		return $FAILURE
759	fi
760	if [ ! "$index" ]; then
761		f_dprintf "$funcname: NULL index argument"
762		msg_error="$msg_error: $funcname" \
763			f_show_err "$msg_null_index_argument"
764		return $FAILURE
765	fi
766	if ! f_isinteger "$index"; then
767		f_dprintf "$funcname: Invalid index argument \`%s'" "$index"
768		msg_error="$msg_error: $funcname" \
769			f_show_err "$msg_invalid_index_argument" "$index"
770		return $FAILURE
771	fi
772	f_dprintf "$funcname: disk=[%s] index=[%s]" "$disk" "$index"
773
774	# Check for unknown partition scheme before proceeding further
775	case "$ZFSBOOT_PARTITION_SCHEME" in
776	""|MBR|GPT) : known good ;;
777	*)
778		f_dprintf "$funcname: %s is an unsupported partition scheme" \
779		          "$ZFSBOOT_PARTITION_SCHEME"
780		msg_error="$msg_error: $funcname" f_show_err \
781			"$msg_unsupported_partition_scheme" \
782			"$ZFSBOOT_PARTITION_SCHEME"
783		return $FAILURE
784	esac
785
786	#
787	# Destroy whatever partition layout is currently on disk.
788	# NOTE: `-F' required to destroy if partitions still exist.
789	# NOTE: Failure is ok here, blank disk will have nothing to destroy.
790	#
791	f_dprintf "$funcname: Destroying all data/layouts on \`%s'..." "$disk"
792	f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" $disk
793	f_eval_catch -d $funcname graid "$GRAID_DELETE" $disk
794	f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" /dev/$disk
795
796	# Make doubly-sure backup GPT is destroyed
797	f_eval_catch -d $funcname gpart "$GPART_CREATE" gpt $disk
798	f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" $disk
799
800	#
801	# Enable boot pool if encryption is desired
802	#
803	[ "$ZFSBOOT_GELI_ENCRYPTION" ] && ZFSBOOT_BOOT_POOL=1
804
805	#
806	# Lay down the desired type of partition scheme
807	#
808	local setsize mbrindex
809	case "$ZFSBOOT_PARTITION_SCHEME" in
810	""|GPT) f_dprintf "$funcname: Creating GPT layout..."
811		#
812		# 1. Create GPT layout using labels
813		#
814		f_eval_catch $funcname gpart "$GPART_CREATE" gpt $disk ||
815		             return $FAILURE
816
817		#
818		# 2. Add small freebsd-boot partition labeled `boot#'
819		#
820		f_eval_catch $funcname gpart "$GPART_ADD_LABEL_WITH_SIZE" \
821		             gptboot$index freebsd-boot 512k $disk ||
822		             return $FAILURE
823		f_eval_catch $funcname gpart "$GPART_BOOTCODE_PART" \
824		             /boot/pmbr /boot/gptzfsboot 1 $disk ||
825		             return $FAILURE
826
827		# NB: zpool will use the `zfs#' GPT labels
828		bootpart=p2 swappart=p2 targetpart=p2
829		[ ${swapsize:-0} -gt 0 ] && targetpart=p3
830
831		#
832		# Prepare boot pool if enabled (e.g., for geli(8))
833		#
834		if [ "$ZFSBOOT_BOOT_POOL" ]; then
835			bootpart=p2 swappart=p3 targetpart=p3
836			[ ${swapsize:-0} -gt 0 ] && targetpart=p4
837			f_eval_catch $funcname gpart \
838			             "$GPART_ADD_LABEL_WITH_SIZE" boot$index \
839			             freebsd-zfs ${bootsize}b $disk ||
840			             return $FAILURE
841			# Pedantically nuke any old labels
842			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
843			                /dev/$disk$bootpart
844			if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
845				# Pedantically detach targetpart for later
846				f_eval_catch -d $funcname geli \
847				                "$GELI_DETACH_F" \
848				                /dev/$disk$targetpart
849			fi
850		fi
851
852		#
853		# 3. Add freebsd-swap partition labeled `swap#'
854		#
855		if [ ${swapsize:-0} -gt 0 ]; then
856			f_eval_catch $funcname gpart \
857			             "$GPART_ADD_LABEL_WITH_SIZE" swap$index \
858			             freebsd-swap ${swapsize}b $disk ||
859			             return $FAILURE
860			# Pedantically nuke any old labels on the swap
861			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
862			                /dev/$disk$swappart
863		fi
864
865		#
866		# 4. Add freebsd-zfs partition labeled `zfs#' for zroot
867		#
868		f_eval_catch $funcname gpart "$GPART_ADD_LABEL" \
869		             zfs$index freebsd-zfs $disk || return $FAILURE
870		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
871		                /dev/$disk$targetpart
872		;;
873
874	MBR) f_dprintf "$funcname: Creating MBR layout..."
875		#
876		# 1. Create MBR layout (no labels)
877		#
878		f_eval_catch $funcname gpart "$GPART_CREATE" mbr $disk ||
879		             return $FAILURE
880		f_eval_catch $funcname gpart "$GPART_BOOTCODE" /boot/mbr \
881		             $disk || return $FAILURE
882
883		#
884		# 2. Add freebsd slice with all available space
885		#
886		f_eval_catch $funcname gpart "$GPART_ADD" freebsd $disk ||
887		             return $FAILURE
888		f_eval_catch $funcname gpart "$GPART_SET_ACTIVE" 1 $disk ||
889		             return $FAILURE
890		# Pedantically nuke any old labels
891		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
892		                /dev/${disk}s1
893		# Pedantically nuke any old scheme
894		f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" ${disk}s1
895
896		#
897		# 3. Write BSD scheme to the freebsd slice
898		#
899		f_eval_catch $funcname gpart "$GPART_CREATE" BSD ${disk}s1 ||
900		             return $FAILURE
901
902		# NB: zpool will use s1a (no labels)
903		bootpart=s1a swappart=s1b targetpart=s1d mbrindex=4
904
905		#
906		# Always prepare a boot pool on MBR
907		#
908		ZFSBOOT_BOOT_POOL=1
909		f_eval_catch $funcname gpart \
910		             "$GPART_ADD_INDEX_WITH_SIZE" \
911		             1 freebsd-zfs ${bootsize}b ${disk}s1 ||
912		             return $FAILURE
913		# Pedantically nuke any old labels
914		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
915		                /dev/$disk$bootpart
916		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
917			# Pedantically detach targetpart for later
918			f_eval_catch -d $funcname geli \
919			                "$GELI_DETACH_F" \
920					/dev/$disk$targetpart
921		fi
922
923		#
924		# 4. Add freebsd-swap partition
925		#
926		if [ ${swapsize:-0} -gt 0 ]; then
927			f_eval_catch $funcname gpart \
928			             "$GPART_ADD_INDEX_WITH_SIZE" 2 \
929			             freebsd-swap ${swapsize}b ${disk}s1 ||
930			             return $FAILURE
931			# Pedantically nuke any old labels on the swap
932			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
933			                /dev/${disk}s1b
934		fi
935
936		#
937		# 5. Add freebsd-zfs partition for zroot
938		#
939		f_eval_catch $funcname gpart "$GPART_ADD_INDEX" \
940			     $mbrindex freebsd-zfs ${disk}s1 || return $FAILURE
941		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
942				/dev/$disk$targetpart # Pedantic
943		f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
944			     /boot/zfsboot /dev/${disk}s1 count=1 ||
945			     return $FAILURE
946		;;
947
948	esac # $ZFSBOOT_PARTITION_SCHEME
949
950	# Update fstab(5)
951	if [ "$isswapmirror" ]; then
952		# This is not the first disk in the mirror, do nothing
953	elif [ "$ZFSBOOT_SWAP_ENCRYPTION" -a "$ZFSBOOT_SWAP_MIRROR" ]; then
954		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
955		             /dev/mirror/swap.eli none swap sw 0 0 \
956		             $BSDINSTALL_TMPETC/fstab ||
957		             return $FAILURE
958		isswapmirror=1
959	elif [ "$ZFSBOOT_SWAP_MIRROR" ]; then
960		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
961		             /dev/mirror/swap none swap sw 0 0 \
962		             $BSDINSTALL_TMPETC/fstab ||
963		             return $FAILURE
964		isswapmirror=1
965	elif [ "$ZFSBOOT_SWAP_ENCRYPTION" ]; then
966		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
967		             /dev/$disk${swappart}.eli none swap sw 0 0 \
968		             $BSDINSTALL_TMPETC/fstab ||
969		             return $FAILURE
970	else
971		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
972		             /dev/$disk$swappart none swap sw 0 0 \
973		             $BSDINSTALL_TMPETC/fstab ||
974		             return $FAILURE
975	fi
976
977	return $SUCCESS
978}
979
980# zfs_create_boot $poolname $vdev_type $disks ...
981#
982# Creates boot pool and dataset layout. Returns error if something goes wrong.
983# Errors are printed to stderr for collection and display.
984#
985zfs_create_boot()
986{
987	local funcname=zfs_create_boot
988	local zroot_name="$1"
989	local zroot_vdevtype="$2"
990	local zroot_vdevs= # Calculated below
991	local swap_devs= # Calculated below
992	local boot_vdevs= # Used for geli(8) and/or MBR layouts
993	shift 2 # poolname vdev_type
994	local disks="$*" disk
995	local isswapmirror
996	local bootpart targetpart swappart # Set by zfs_create_diskpart() below
997	local create_options
998
999	#
1000	# Pedantic checks; should never be seen
1001	#
1002	if [ ! "$zroot_name" ]; then
1003		f_dprintf "$funcname: NULL poolname"
1004		msg_error="$msg_error: $funcname" \
1005			f_show_err "$msg_null_poolname"
1006		return $FAILURE
1007	fi
1008	if [ $# -lt 1 ]; then
1009		f_dprintf "$funcname: missing disk arguments"
1010		msg_error="$msg_error: $funcname" \
1011			f_show_err "$msg_missing_disk_arguments"
1012		return $FAILURE
1013	fi
1014	f_dprintf "$funcname: poolname=[%s] vdev_type=[%s]" \
1015	          "$zroot_name" "$zroot_vdevtype"
1016
1017	#
1018	# Initialize fstab(5)
1019	#
1020	f_dprintf "$funcname: Initializing temporary fstab(5) file..."
1021	f_eval_catch $funcname sh "$SHELL_TRUNCATE" $BSDINSTALL_TMPETC/fstab ||
1022	             return $FAILURE
1023	f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1024	             "# Device" Mountpoint FStype Options Dump "Pass#" \
1025	             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1026
1027	#
1028	# Expand SI units in desired sizes
1029	#
1030	f_dprintf "$funcname: Expanding supplied size values..."
1031	local swapsize bootsize
1032	if ! f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize; then
1033		f_dprintf "$funcname: Invalid swap size \`%s'" \
1034		          "$ZFSBOOT_SWAP_SIZE"
1035		f_show_err "$msg_invalid_swap_size" "$ZFSBOOT_SWAP_SIZE"
1036		return $FAILURE
1037	fi
1038	if ! f_expand_number "$ZFSBOOT_BOOT_POOL_SIZE" bootsize; then
1039		f_dprintf "$funcname: Invalid boot pool size \`%s'" \
1040		          "$ZFSBOOT_BOOT_POOL_SIZE"
1041		f_show_err "$msg_invalid_boot_pool_size" \
1042		           "$ZFSBOOT_BOOT_POOL_SIZE"
1043		return $FAILURE
1044	fi
1045	f_dprintf "$funcname: ZFSBOOT_SWAP_SIZE=[%s] swapsize=[%s]" \
1046	          "$ZFSBOOT_SWAP_SIZE" "$swapsize"
1047	f_dprintf "$funcname: ZFSBOOT_BOOT_POOL_SIZE=[%s] bootsize=[%s]" \
1048	          "$ZFSBOOT_BOOT_POOL_SIZE" "$bootsize"
1049
1050	#
1051	# Destroy the pool in-case this is our second time 'round (case of
1052	# failure and installer presented ``Retry'' option to come back).
1053	#
1054	# NB: If we don't destroy the pool, later gpart(8) destroy commands
1055	# that try to clear existing partitions (see zfs_create_diskpart())
1056	# will fail with a `Device Busy' error, leading to `GEOM exists'.
1057	#
1058	f_eval_catch -d $funcname zpool "$ZPOOL_DESTROY" "$zroot_name"
1059
1060	#
1061	# Prepare the disks and build pool device list(s)
1062	#
1063	f_dprintf "$funcname: Preparing disk partitions for ZFS pool..."
1064
1065	# Force 4K sectors using vfs.zfs.min_auto_ashift=12
1066	if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1067		f_dprintf "$funcname: With 4K sectors..."
1068		f_eval_catch $funcname sysctl "$SYSCTL_ZFS_MIN_ASHIFT_12" \
1069		    || return $FAILURE
1070	fi
1071	local n=0
1072	for disk in $disks; do
1073		zfs_create_diskpart $disk $n || return $FAILURE
1074		# Now $bootpart, $targetpart, and $swappart are set (suffix
1075		# for $disk)
1076		if [ "$ZFSBOOT_BOOT_POOL" ]; then
1077			boot_vdevs="$boot_vdevs $disk$bootpart"
1078		fi
1079		zroot_vdevs="$zroot_vdevs $disk$targetpart"
1080		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1081			zroot_vdevs="$zroot_vdevs.eli"
1082		fi
1083
1084		n=$(( $n + 1 ))
1085	done # disks
1086
1087	#
1088	# If we need/want a boot pool, create it
1089	#
1090	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1091		local bootpool_vdevtype= # Calculated below
1092		local bootpool_options= # Calculated below
1093		local bootpool_name="$ZFSBOOT_BOOT_POOL_NAME"
1094		local bootpool="$BSDINSTALL_CHROOT/$bootpool_name"
1095		local zroot_key="${ZFSBOOT_GELI_KEY_FILE#/}"
1096
1097		f_dprintf "$funcname: Setting up boot pool..."
1098		[ "$ZFSBOOT_GELI_ENCRYPTION" ] &&
1099			f_dprintf "$funcname: For encrypted root disk..."
1100
1101		# Create parent directory for boot pool
1102		f_eval_catch -d $funcname umount "$UMOUNT" /mnt
1103		f_eval_catch $funcname mount "$MOUNT_TYPE" tmpfs none \
1104		             $BSDINSTALL_CHROOT || return $FAILURE
1105
1106		# Create mirror across the boot partition on all disks
1107		local nvdevs
1108		f_count nvdevs $boot_vdevs
1109		[ $nvdevs -gt 1 ] && bootpool_vdevtype=mirror
1110
1111		create_options="$ZFSBOOT_BOOT_POOL_CREATE_OPTIONS"
1112		bootpool_options="-o altroot=$BSDINSTALL_CHROOT"
1113		bootpool_options="$bootpool_options $create_options"
1114		bootpool_options="$bootpool_options -m \"/$bootpool_name\" -f"
1115		f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1116		             "$bootpool_options" "$bootpool_name" \
1117		             "$bootpool_vdevtype" "$boot_vdevs" ||
1118		             return $FAILURE
1119
1120		f_eval_catch $funcname mkdir "$MKDIR_P" "$bootpool/boot" ||
1121		             return $FAILURE
1122
1123		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1124			# Generate an encryption key using random(4)
1125			f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1126				     /dev/random "$bootpool/$zroot_key" \
1127			             "bs=4096 count=1" || return $FAILURE
1128			f_eval_catch $funcname chmod "$CHMOD_MODE" \
1129			             go-wrx "$bootpool/$zroot_key" ||
1130			             return $FAILURE
1131		else
1132			# Clean up
1133			f_eval_catch $funcname zfs "$ZFS_UNMOUNT" \
1134			             "$bootpool_name" || return $FAILURE
1135			f_eval_catch -d $funcname umount "$UMOUNT" /mnt # tmpfs
1136		fi
1137
1138	fi
1139
1140	#
1141	# Create the geli(8) GEOMS
1142	#
1143	if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1144		# Prompt user for password (twice)
1145		if ! msg_enter_new_password="$msg_geli_password" \
1146			f_dialog_input_password
1147		then
1148			f_dprintf "$funcname: User cancelled"
1149			f_show_err "$msg_user_cancelled"
1150			return $FAILURE
1151		fi
1152
1153		# Initialize geli(8) on each of the target partitions
1154		for disk in $disks; do
1155			f_dialog_info "$msg_geli_setup" \
1156				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
1157			if ! echo "$pw_password" | f_eval_catch \
1158				$funcname geli "$GELI_PASSWORD_INIT" \
1159				"$bootpool/boot/$disk$targetpart.eli" \
1160				AES-XTS "$bootpool/$zroot_key" \
1161				$disk$targetpart
1162			then
1163				f_interactive || f_die
1164				unset pw_password # Sensitive info
1165				return $FAILURE
1166			fi
1167			if ! echo "$pw_password" | f_eval_catch \
1168				$funcname geli "$GELI_ATTACH" \
1169				"$bootpool/$zroot_key" $disk$targetpart
1170			then
1171				f_interactive || f_die
1172				unset pw_password # Sensitive info
1173				return $FAILURE
1174			fi
1175		done
1176		unset pw_password # Sensitive info
1177
1178		# Clean up
1179		f_eval_catch $funcname zfs "$ZFS_UNMOUNT" "$bootpool_name" ||
1180			return $FAILURE
1181		f_eval_catch -d $funcname umount "$UMOUNT" /mnt # tmpfs
1182	fi
1183	#
1184	# Create the gmirror(8) GEOMS for swap
1185	#
1186	if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1187		for disk in $disks; do
1188			swap_devs="$swap_devs $disk$swappart"
1189		done
1190		f_eval_catch $funcname gmirror "$SWAP_GMIRROR_LABEL" \
1191			"$swap_devs" || return $FAILURE
1192	fi
1193
1194	#
1195	# Create the ZFS root pool with desired type and disk devices
1196	#
1197	f_dprintf "$funcname: Creating root pool..."
1198	create_options="$ZFSBOOT_POOL_CREATE_OPTIONS"
1199	f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1200		"-o altroot=$BSDINSTALL_CHROOT $create_options -m none -f" \
1201		"$zroot_name" "$zroot_vdevtype" "$zroot_vdevs" ||
1202		return $FAILURE
1203
1204	#
1205	# Create ZFS dataset layout within the new root pool
1206	#
1207	f_dprintf "$funcname: Creating ZFS datasets..."
1208	echo "$ZFSBOOT_DATASETS" | while read dataset options; do
1209		# Skip blank lines and comments
1210		case "$dataset" in "#"*|"") continue; esac
1211		# Remove potential inline comments in options
1212		options="${options%%#*}"
1213		# Replace tabs with spaces
1214		f_replaceall "$options" "	" " " options
1215		# Reduce contiguous runs of space to one single space
1216		oldoptions=
1217		while [ "$oldoptions" != "$options" ]; do
1218			oldoptions="$options"
1219			f_replaceall "$options" "  " " " options
1220		done
1221		# Replace both commas and spaces with ` -o '
1222		f_replaceall "$options" "[ ,]" " -o " options
1223		# Create the dataset with desired options
1224		f_eval_catch $funcname zfs "$ZFS_CREATE_WITH_OPTIONS" \
1225		             "${options:+-o $options}" "$zroot_name$dataset" ||
1226		             return $FAILURE
1227	done
1228
1229	# Touch up permissions on the tmp directories
1230	f_dprintf "$funcname: Modifying directory permissions..."
1231	local dir
1232	for dir in /tmp /var/tmp; do
1233		f_eval_catch $funcname chmod "$CHMOD_MODE" 1777 \
1234		             $BSDINSTALL_CHROOTDIR$dir || return $FAILURE
1235	done
1236
1237	# Create symlink(s)
1238	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1239		f_dprintf "$funcname: Creating /boot symlink for boot pool..."
1240		f_eval_catch $funcname ln "$LN_SF" "$bootpool_name/boot" \
1241		             $BSDINSTALL_CHROOT/boot || return $FAILURE
1242	fi
1243
1244	# Set bootfs property
1245	local zroot_bootfs="$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME"
1246	f_dprintf "$funcname: Setting bootfs property..."
1247	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1248		"bootfs=\"$zroot_name/$zroot_bootfs\"" "$zroot_name" ||
1249		return $FAILURE
1250
1251	# Export the pool(s)
1252	f_dprintf "$funcname: Temporarily exporting ZFS pool(s)..."
1253	f_eval_catch $funcname zpool "$ZPOOL_EXPORT" "$zroot_name" ||
1254	             return $FAILURE
1255	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1256		f_eval_catch $funcname zpool "$ZPOOL_EXPORT" \
1257		             "$bootpool_name" || return $FAILURE
1258	fi
1259
1260	# MBR boot loader touch-up
1261	if [ "$ZFSBOOT_PARTITION_SCHEME" = "MBR" ]; then
1262		f_dprintf "$funcname: Updating MBR boot loader on disks..."
1263		# Stick the ZFS boot loader in the "convienient hole" after 
1264		# the ZFS internal metadata
1265		for disk in $disks; do
1266			f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1267			             /boot/zfsboot /dev/$disk$bootpart \
1268			             "skip=1 seek=1024" || return $FAILURE
1269		done
1270	fi
1271
1272	# Re-import the ZFS pool(s)
1273	f_dprintf "$funcname: Re-importing ZFS pool(s)..."
1274	f_eval_catch $funcname zpool "$ZPOOL_IMPORT_WITH_OPTIONS" \
1275	             "-o altroot=\"$BSDINSTALL_CHROOT\"" "$zroot_name" ||
1276	             return $FAILURE
1277	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1278		f_eval_catch $funcname zpool "$ZPOOL_IMPORT_WITH_OPTIONS" \
1279		             "-o altroot=\"$BSDINSTALL_CHROOT\"" \
1280		             "$bootpool_name" || return $FAILURE
1281	fi
1282
1283	# While this is apparently not needed, it seems to help MBR
1284	f_dprintf "$funcname: Configuring zpool.cache for zroot..."
1285	f_eval_catch $funcname mkdir "$MKDIR_P" $BSDINSTALL_CHROOT/boot/zfs ||
1286	             return $FAILURE
1287	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1288	             "cachefile=\"$BSDINSTALL_CHROOT/boot/zfs/zpool.cache\"" \
1289	             "$zroot_name" || return $FAILURE
1290
1291	# Last, but not least... required lines for rc.conf(5)/loader.conf(5)
1292	# NOTE: We later concatenate these into their destination
1293	f_dprintf "%s: Configuring rc.conf(5)/loader.conf(5) additions..." \
1294	          "$funcname"
1295	f_eval_catch $funcname echo "$ECHO_APPEND" 'zfs_enable=\"YES\"' \
1296	             $BSDINSTALL_TMPETC/rc.conf.zfs || return $FAILURE
1297	f_eval_catch $funcname echo "$ECHO_APPEND" \
1298	             'kern.geom.label.gptid.enable=\"0\"' \
1299	             $BSDINSTALL_TMPBOOT/loader.conf.zfs || return $FAILURE
1300
1301	if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1302		f_eval_catch $funcname echo "$ECHO_APPEND" 'geom_mirror_load=\"YES\"' \
1303		             $BSDINSTALL_TMPBOOT/loader.conf.gmirror || return $FAILURE
1304	fi
1305
1306	# We're all done unless we should go on for boot pool
1307	[ "$ZFSBOOT_BOOT_POOL" ] || return $SUCCESS
1308
1309	# Set cachefile for boot pool so it auto-imports at system start
1310	f_dprintf "$funcname: Configuring zpool.cache for boot pool..."
1311	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1312	             "cachefile=\"$BSDINSTALL_CHROOT/boot/zfs/zpool.cache\"" \
1313	             "$bootpool_name" || return $FAILURE
1314
1315	# Some additional geli(8) requirements for loader.conf(5)
1316	for option in \
1317		'zpool_cache_load=\"YES\"' \
1318		'zpool_cache_type=\"/boot/zfs/zpool.cache\"' \
1319		'zpool_cache_name=\"/boot/zfs/zpool.cache\"' \
1320	; do
1321		f_eval_catch $funcname echo "$ECHO_APPEND" "$option" \
1322		             $BSDINSTALL_TMPBOOT/loader.conf.zfs ||
1323		             return $FAILURE
1324	done
1325	f_eval_catch $funcname printf "$PRINTF_CONF" vfs.root.mountfrom \
1326	    "\"zfs:$zroot_name/$zroot_bootfs\"" \
1327	    $BSDINSTALL_TMPBOOT/loader.conf.root || return $FAILURE
1328
1329	# We're all done unless we should go on to do encryption
1330	[ "$ZFSBOOT_GELI_ENCRYPTION" ] || return $SUCCESS
1331
1332	#
1333	# Configure geli(8)-based encryption
1334	#
1335	f_dprintf "$funcname: Configuring disk encryption..."
1336	f_eval_catch $funcname echo "$ECHO_APPEND" 'aesni_load=\"YES\"' \
1337	    $BSDINSTALL_TMPBOOT/loader.conf.aesni || return $FAILURE
1338	f_eval_catch $funcname echo "$ECHO_APPEND" 'geom_eli_load=\"YES\"' \
1339	    $BSDINSTALL_TMPBOOT/loader.conf.geli || return $FAILURE
1340	f_eval_catch $funcname echo "$ECHO_APPEND" \
1341		'geom_eli_passphrase_prompt=\"YES\"' \
1342		$BSDINSTALL_TMPBOOT/loader.conf.geli || return $FAILURE
1343	for disk in $disks; do
1344		f_eval_catch $funcname printf "$PRINTF_CONF" \
1345			geli_%s_keyfile0_load "$disk$targetpart YES" \
1346			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1347			return $FAILURE
1348		f_eval_catch $funcname printf "$PRINTF_CONF" \
1349			geli_%s_keyfile0_type \
1350			"$disk$targetpart $disk$targetpart:geli_keyfile0" \
1351			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1352			return $FAILURE
1353		f_eval_catch $funcname printf "$PRINTF_CONF" \
1354			geli_%s_keyfile0_name \
1355			"$disk$targetpart \"$ZFSBOOT_GELI_KEY_FILE\"" \
1356			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1357			return $FAILURE
1358	done
1359
1360	return $SUCCESS
1361}
1362
1363# dialog_menu_diskinfo
1364#
1365# Prompt the user to select a disk and then provide detailed info on it.
1366#
1367dialog_menu_diskinfo()
1368{
1369	local device disk
1370
1371	#
1372	# Break from loop when user cancels disk selection
1373	#
1374	while :; do
1375		device=$( msg_cancel="$msg_back" f_device_menu \
1376			"$DIALOG_TITLE" "$msg_select_a_disk_device" "" \
1377			$DEVICE_TYPE_DISK 2>&1 ) || break
1378		$device get name disk
1379
1380		# Show gpart(8) `show' and camcontrol(8) `inquiry' data
1381		f_show_msg "$msg_detailed_disk_info" \
1382			"$disk" "$( gpart show $disk 2> /dev/null )" \
1383			"$disk" "$( camcontrol inquiry $disk 2> /dev/null )" \
1384			"$disk" "$( camcontrol identify $disk 2> /dev/null )"
1385	done
1386
1387	return $SUCCESS
1388}
1389
1390############################################################ MAIN
1391
1392#
1393# Initialize
1394#
1395f_dialog_title "$msg_zfs_configuration"
1396f_dialog_backtitle "$msg_freebsd_installer"
1397
1398# User may have specifically requested ZFS-related operations be interactive
1399! f_interactive && f_zfsinteractive && unset $VAR_NONINTERACTIVE
1400
1401#
1402# Debugging
1403#
1404f_dprintf "BSDINSTALL_CHROOT=[%s]" "$BSDINSTALL_CHROOT"
1405f_dprintf "BSDINSTALL_TMPETC=[%s]" "$BSDINSTALL_TMPETC"
1406f_dprintf "FSTAB_FMT=[%s]" "$FSTAB_FMT"
1407
1408#
1409# If the system was booted with UEFI, warn the user that FreeBSD can't do
1410# ZFS with UEFI yet
1411#
1412if f_interactive; then
1413    bootmethod=$(sysctl -n machdep.bootmethod)
1414    f_dprintf "machdep.bootmethod=[%s]" "$bootmethod"
1415    if [ "$bootmethod" != "BIOS" ]; then
1416	dialog_uefi_prompt
1417	retval=$?
1418	f_dprintf "uefi_prompt=[%s]" "$retval"
1419	[ $retval -eq $DIALOG_OK ] || f_die
1420    fi
1421fi
1422
1423#
1424# Loop over the main menu until we've accomplished what we came here to do
1425#
1426while :; do
1427	if ! f_interactive; then
1428		retval=$DIALOG_OK
1429		mtag=">>> $msg_install"
1430	else
1431		dialog_menu_main
1432		retval=$?
1433		f_dialog_menutag_fetch mtag
1434	fi
1435
1436	f_dprintf "retval=%u mtag=[%s]" $retval "$mtag"
1437	[ $retval -eq $DIALOG_OK ] || f_die
1438
1439	case "$mtag" in
1440	">>> $msg_install")
1441		#
1442		# First, validate the user's selections
1443		#
1444
1445		# Make sure they gave us a name for the pool
1446		if [ ! "$ZFSBOOT_POOL_NAME" ]; then
1447			f_dprintf "Pool name cannot be empty."
1448			f_show_err "$msg_pool_name_cannot_be_empty"
1449			continue
1450		fi
1451
1452		# Validate vdev type against number of disks selected/scripted
1453		# (also validates that ZFSBOOT_DISKS are real [probed] disks)
1454		# NB: dialog_menu_layout supports running non-interactively
1455		dialog_menu_layout || continue
1456
1457		# Make sure each disk will be at least 50% ZFS
1458		if f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize &&
1459		   f_expand_number "$ZFSBOOT_BOOT_POOL_SIZE" bootsize
1460		then
1461			minsize=$swapsize teeny_disks=
1462			[ "$ZFSBOOT_BOOT_POOL" ] &&
1463				minsize=$(( $minsize + $bootsize ))
1464			for disk in $ZFSBOOT_DISKS; do
1465				debug= f_device_find -1 \
1466					$disk $DEVICE_TYPE_DISK device
1467				$device get capacity disksize || continue
1468				[ ${disksize:-0} -ge 0 ] || disksize=0
1469				disksize=$(( $disksize - $minsize ))
1470				[ $disksize -lt $minsize ] &&
1471					teeny_disks="$teeny_disks $disk"
1472			done
1473			if [ "$teeny_disks" ]; then
1474				f_dprintf "swapsize=[%s] bootsize[%s] %s" \
1475				          "$ZFSBOOT_SWAP_SIZE" \
1476				          "$ZFSBOOT_BOOT_POOL_SIZE" \
1477				          "minsize=[$minsize]"
1478				f_dprintf "These disks are too small: %s" \
1479				          "$teeny_disks"
1480				f_show_err "$msg_these_disks_are_too_small" \
1481				           "$ZFSBOOT_SWAP_SIZE" \
1482				           "$ZFSBOOT_BOOT_POOL_SIZE" \
1483				           "$teeny_disks"
1484				continue
1485			fi
1486		fi
1487
1488		#
1489		# Last Chance!
1490		#
1491		if f_interactive; then
1492			dialog_last_chance $ZFSBOOT_DISKS || continue
1493		fi
1494
1495		#
1496		# Let's do this
1497		#
1498
1499		vdev_type="$ZFSBOOT_VDEV_TYPE"
1500
1501		# Blank the vdev type for the default layout
1502		[ "$vdev_type" = "stripe" ] && vdev_type=
1503
1504		zfs_create_boot "$ZFSBOOT_POOL_NAME" \
1505		                "$vdev_type" $ZFSBOOT_DISKS || continue
1506
1507		break # to success
1508		;;
1509	?" $msg_pool_type_disks")
1510		ZFSBOOT_CONFIRM_LAYOUT=1
1511		dialog_menu_layout
1512		# User has poked settings, disable later confirmation
1513		ZFSBOOT_CONFIRM_LAYOUT=
1514		;;
1515	"- $msg_rescan_devices") f_device_rescan ;;
1516	"- $msg_disk_info") dialog_menu_diskinfo ;;
1517	?" $msg_pool_name")
1518		# Prompt the user to input/change the name for the new pool
1519		f_dialog_input input \
1520			"$msg_please_enter_a_name_for_your_zpool" \
1521			"$ZFSBOOT_POOL_NAME" &&
1522			ZFSBOOT_POOL_NAME="$input"
1523		;;
1524	?" $msg_force_4k_sectors")
1525		# Toggle the variable referenced both by the menu and later
1526		if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1527			ZFSBOOT_FORCE_4K_SECTORS=
1528		else
1529			ZFSBOOT_FORCE_4K_SECTORS=1
1530		fi
1531		;;
1532	?" $msg_encrypt_disks")
1533		# Toggle the variable referenced both by the menu and later
1534		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1535			ZFSBOOT_GELI_ENCRYPTION=
1536		else
1537			ZFSBOOT_FORCE_4K_SECTORS=1
1538			ZFSBOOT_GELI_ENCRYPTION=1
1539		fi
1540		;;
1541	?" $msg_partition_scheme")
1542		# Toggle between GPT and MBR
1543		if [ "$ZFSBOOT_PARTITION_SCHEME" = GPT ]; then
1544			ZFSBOOT_PARTITION_SCHEME=MBR
1545		else
1546			ZFSBOOT_PARTITION_SCHEME=GPT
1547		fi
1548		;;
1549	?" $msg_swap_size")
1550		# Prompt the user to input/change the swap size for each disk
1551		f_dialog_input input \
1552			"$msg_please_enter_amount_of_swap_space" \
1553			"$ZFSBOOT_SWAP_SIZE" &&
1554			ZFSBOOT_SWAP_SIZE="${input:-0}"
1555		;;
1556	?" $msg_swap_mirror")
1557		# Toggle the variable referenced both by the menu and later
1558		if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1559			ZFSBOOT_SWAP_MIRROR=
1560		else
1561			ZFSBOOT_SWAP_MIRROR=1
1562		fi
1563		;;
1564	?" $msg_swap_encrypt")
1565		# Toggle the variable referenced both by the menu and later
1566		if [ "$ZFSBOOT_SWAP_ENCRYPTION" ]; then
1567			ZFSBOOT_SWAP_ENCRYPTION=
1568		else
1569			ZFSBOOT_SWAP_ENCRYPTION=1
1570		fi
1571		;;
1572	esac
1573done
1574
1575return $SUCCESS
1576
1577################################################################################
1578# END
1579################################################################################
1580